<?php
namespace bwdhsx_hero_section_namespace;

use bwdhsx_hero_section_namespace\PageSettings\Page_Settings;
define( "BWDHSX_ASFSK_ASSETS_PUBLIC_DIR_FILE", plugin_dir_url( __FILE__ ) . "assets/public" );
define( "BWDHSX_ASFSK_ASSETS_ADMIN_DIR_FILE", plugin_dir_url( __FILE__ ) . "assets/admin" );
class Classbwdhsx_hero_section {

	private static $_instance = null;

	public static function instance() {
		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	public function bwdhsx_admin_editor_scripts() {
		add_filter( 'script_loader_tag', [ $this, 'bwdhsx_admin_editor_scripts_as_a_module' ], 10, 2 );
	}

	public function bwdhsx_admin_editor_scripts_as_a_module( $tag, $handle ) {
		if ( 'bwdhsx_herosections_editor' === $handle ) {
			$tag = str_replace( '<script', '<script type="module"', $tag );
		}

		return $tag;
	}

	private function include_widgets_files() {
		require_once( __DIR__ . '/widgets/bwdhsx-hero-section-widgets1.php' );
		require_once( __DIR__ . '/widgets/bwdhsx-hero-section-widgets2.php' );
		require_once( __DIR__ . '/widgets/bwdhsx-hero-section-widgets3.php' );
		require_once( __DIR__ . '/widgets/bwdhsx-hero-section-widgets4.php' );
		require_once( __DIR__ . '/widgets/bwdhsx-hero-section-widgets5.php' );
		require_once( __DIR__ . '/widgets/bwdhsx-hero-section-widgets6.php' );
		require_once( __DIR__ . '/widgets/bwdhsx-hero-section-widgets7.php' );
		require_once( __DIR__ . '/widgets/bwdhsx-hero-section-widgets8.php' );
		require_once( __DIR__ . '/widgets/bwdhsx-hero-section-widgets9.php' );
		require_once( __DIR__ . '/widgets/bwdhsx-hero-section-widgets10.php' );
		require_once( __DIR__ . '/widgets/bwdhsx-hero-section-widgets11.php' );
		require_once( __DIR__ . '/widgets/bwdhsx-hero-section-widgets12.php' );
		require_once( __DIR__ . '/widgets/bwdhsx-hero-section-widgets13.php' );
	}

	public function bwdhsx_register_widgets() {
		// Its is now safe to include Widgets files
		$this->include_widgets_files();

		// Register WidgetsF
		$bwdhsx_herosection_style1 = get_option( 'bwdhsx-check-hero-widget1', 'off' );
		if ( $bwdhsx_herosection_style1 == 'on' ) {
			\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\bwdhsx_hero_section_widgets1());
		}
		$bwdhsx_herosection_style2 = get_option( 'bwdhsx-check-hero-widget2', 'off' );
		if ( $bwdhsx_herosection_style2 == 'on' ) {
			\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\bwdhsx_hero_section_widgets2());
		}
		$bwdhsx_herosection_style3 = get_option( 'bwdhsx-check-hero-widget3', 'off' );
		if ( $bwdhsx_herosection_style3 == 'on' ) {
			\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\bwdhsx_hero_section_widgets3());
		}
		$bwdhsx_herosection_style4 = get_option( 'bwdhsx-check-hero-widget4', 'off' );
		if ( $bwdhsx_herosection_style4 == 'on' ) {
			\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\bwdhsx_hero_section_widgets4());
		}
		$bwdhsx_herosection_style5 = get_option( 'bwdhsx-check-hero-widget5', 'off' );
		if ( $bwdhsx_herosection_style5 == 'on' ) {
			\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\bwdhsx_hero_section_widgets5());
		}
		$bwdhsx_herosection_style6 = get_option( 'bwdhsx-check-hero-widget6', 'off' );
		if ( $bwdhsx_herosection_style6 == 'on' ) {
			\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\bwdhsx_hero_section_widgets6());
		}
		$bwdhsx_herosection_style7 = get_option( 'bwdhsx-check-hero-widget7', 'off' );
		if ( $bwdhsx_herosection_style7 == 'on' ) {
			\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\bwdhsx_hero_section_widgets7());
		}
		$bwdhsx_herosection_style8 = get_option( 'bwdhsx-check-hero-widget8', 'off' );
		if ( $bwdhsx_herosection_style8 == 'on' ) {
			\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\bwdhsx_hero_section_widgets8());
		}
		$bwdhsx_herosection_style9 = get_option( 'bwdhsx-check-hero-widget9', 'off' );
		if ( $bwdhsx_herosection_style9 == 'on' ) {
			\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\bwdhsx_hero_section_widgets9());
		}
		$bwdhsx_herosection_style10 = get_option( 'bwdhsx-check-hero-widget10', 'off' );
		if ( $bwdhsx_herosection_style10 == 'on' ) {
			\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\bwdhsx_hero_section_widgets10());
		}
		$bwdhsx_herosection_style11 = get_option( 'bwdhsx-check-hero-widget11', 'off' );
		if ( $bwdhsx_herosection_style11 == 'on' ) {
			\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\bwdhsx_hero_section_widgets11());
		}
		$bwdhsx_herosection_style12 = get_option( 'bwdhsx-check-hero-widget12', 'off' );
		if ( $bwdhsx_herosection_style12 == 'on' ) {
			\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\bwdhsx_hero_section_widgets12());
		}
		$bwdhsx_herosection_style13 = get_option( 'bwdhsx-check-hero-widget13', 'off' );
		if ( $bwdhsx_herosection_style13 == 'on' ) {
			\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\bwdhsx_hero_section_widgets13());
		}

	}

	private function add_page_settings_controls() {
		require_once( __DIR__ . '/page-settings/bwdhsx-hero-section-manager.php' );
		new Page_Settings();
	}

	// Register Category
	function bwdhsx_hero_section_add_elementor_widget_categories( $elements_manager ) {

		$elements_manager->add_category(
			'bwdhsx-hero-section-category',
			[
				'title' => esc_html__( 'Hero Section All Style', BWDHSX_ROOT_AUTHOR ),
				'icon' => 'eicon-person',
			]
		);
	}

	//css-js-link-here
	public function bwdhsx_all_assets_for_the_public(){

		wp_enqueue_script( 'herosections-magnific-pop', plugin_dir_url( __FILE__ ) . 'assets/public/js/jquery.magnific-popup.min.js', array('jquery'), '1.3', true );
		wp_enqueue_script( 'herosections-main', plugin_dir_url( __FILE__ ) . 'assets/public/js/hero.js', array('jquery'), '1.3', true );

		$all_css_file = array(
            'herosections-plugin-fontawesome' => array('bwdhsx_hero_section_css_path_define'=>BWDHSX_ASFSK_ASSETS_PUBLIC_DIR_FILE . '/fontawesome/css/all.min.css'),
            'herosections-plugin-main' => array('bwdhsx_hero_section_css_path_define'=>BWDHSX_ASFSK_ASSETS_PUBLIC_DIR_FILE . '/css/main.css'),
        );
        foreach($all_css_file as $handle => $fileinfo){
            wp_enqueue_style( $handle, $fileinfo['bwdhsx_hero_section_css_path_define'], null, '1.3', 'all');
        }

	}

	//admin-icon
	public function bwdhsx_all_assets_for_elementor_editor_admin(){
		$all_css_js_file = array(
            'herosections-admin-main' => array('bwdhsx_path_admin_define'=>BWDHSX_ASFSK_ASSETS_ADMIN_DIR_FILE . '/css/icon.css'),
        );
        foreach($all_css_js_file as $handle => $fileinfo){
            wp_enqueue_style( $handle, $fileinfo['bwdhsx_path_admin_define'], null, '1.3', 'all');
        }
	}

	public function bwdhsx_all_assets_for_dashboard_admin() {
		wp_enqueue_script( 'herosections-admin-main', plugin_dir_url( __FILE__ ) . 'assets/admin/dashboard/dashboard.js', array('jquery'), '1.3', true );

		wp_enqueue_style( 'bwdhsx-dashboard-admin', plugin_dir_url( __FILE__ ) . 'assets/admin/dashboard/dashboard.css', null, '1.3', 'all' );
	}

	public function bwdhsx_hero_section_main_menu(){
		if(current_user_can('manage_options')){
			add_menu_page(
				'Hero Section',
				'BWD Hero Section',
				'manage_options',
				'bwdhsx-plugin-main-menu',
				array($this, 'bwdhsx_hero_section_plugin_settings'),
				'dashicons-align-full-width', // add a icon here
				30
			);
			add_submenu_page(
				'bwdhsx-plugin-main-menu',
				'Hero Section Dashboard',
				'Dashboard',
				'manage_options',
				'bwdhsx-plugin-main-menu',
				array($this, 'bwdhsx_hero_section_plugin_settings')
			);
			add_submenu_page(
				'bwdhsx-plugin-main-menu',
				'Hero Section Submenu',
				'Get Support',
				'manage_options',
				'get-support',
				array($this, 'bwdhsx_hero_section_plugin_submenu_about_plugin')
			);
		}
    add_action('admin_init', array($this, 'bwdhsx_sections_admin_input'));
	}

	public function bwdhsx_sections_admin_input(){
		// Here have to add all input controls
		include 'includes/bwdhsx-dashboard.php';
	}
	public function bwdhsx_hero_section_plugin_settings(){
		include 'includes/bwdhsx-dashboard-style.php';
	}
	public function bwdhsx_hero_section_plugin_submenu_about_plugin(){
		include 'includes/bwdhsx-support.php';
	}
	public function bwdhsx_plugin_function_for_datas_callback() {}

	public function add_bwdhsx_plugin_settings_to_whitelist( $options ) {
		$options['bwdhsx-plugin-settings'] = array(
			'bwdhsx-check-hero-widget1',
			'bwdhsx-check-hero-widget2',
			'bwdhsx-check-hero-widget3',
			'bwdhsx-check-hero-widget4',
			'bwdhsx-check-hero-widget5',
			'bwdhsx-check-hero-widget6',
			'bwdhsx-check-hero-widget7',
			'bwdhsx-check-hero-widget8',
			'bwdhsx-check-hero-widget9',
			'bwdhsx-check-hero-widget10',
			'bwdhsx-check-hero-widget11',
			'bwdhsx-check-hero-widget12',
			'bwdhsx-check-hero-widget13',
		);
		return $options;
	}

	public function __construct() {

		add_filter( 'whitelist_options', [$this,'add_bwdhsx_plugin_settings_to_whitelist'] );

		add_action( 'admin_menu', [$this, 'bwdhsx_hero_section_main_menu' ]);

		add_action('admin_enqueue_scripts', [$this, 'bwdhsx_all_assets_for_dashboard_admin']);

		// For public assets
		add_action('wp_enqueue_scripts', [$this, 'bwdhsx_all_assets_for_the_public']);

		// For Elementor Editor
		add_action('elementor/editor/before_enqueue_scripts', [$this, 'bwdhsx_all_assets_for_elementor_editor_admin']);

		// Register Category
		add_action( 'elementor/elements/categories_registered', [ $this, 'bwdhsx_hero_section_add_elementor_widget_categories' ] );

		// Register widgets
		add_action( 'elementor/widgets/widgets_registered', [ $this, 'bwdhsx_register_widgets' ] );

		// Register editor scripts
		add_action( 'elementor/editor/after_enqueue_scripts', [ $this, 'bwdhsx_admin_editor_scripts' ] );

		$this->add_page_settings_controls();
	}
}

// Instantiate Plugin Class
Classbwdhsx_hero_section::instance();